// CAMERA_CONTROLLER
// Jf[^ނ߂DDR2 SDRAMAhXo͂
// Yf[^UVf[^o͂BtH[}bgUYVY
// 2010/07/24Fcam_cont_afifo2ȏ̃f[^邱Ƃ߂rd_data_counto̓|[gɒǉ
// 2011/11/03 : XeIJɑΉB2̃JŶ݂DDR2 SDRÃot@̏

`default_nettype none

module Camera_Controller (
	input	wire	clk_cam,	// 25MHzCMOSJpNbN
	input	wire	clk_ddr2,	// 133.33MHzDDR2 SDRAMpNbN
	input	wire	reset_cam,	// clk_cam pZbg
	input	wire	reset_ddr2,	// clk_ddr2 pZbg
	input	wire	cam_href_2d, 	// CMOSJHREF̃b`o(2NbNxj
	input	wire	cam_vsync_2d,	// CMOSJVSYNC̃b`o(2NbNxj
	input	wire	master_sync, 	// M
	input	wire	[7:0]	cam1_data_2d,	// CMOSJ1̋Pxf[^
	input	wire	[7:0]	cam3_data_2d,	// CMOSJ3̋Pxf[^
	output	reg		[18:0]	address,	// AhX
	output	wire	[31:0]	data_out,	// VYUY8rbgtH[}bg̉摜f[^o
	input	wire	addr_enable,	// AhXECl[u
	input	wire	data_enable,	// f[^ECl[u
	input	wire	capture_ena,	// CMOSJf[^݃Cl[u
	output	wire	afifo_empty,	// cam_cont_afifo empty 
	output	wire	[4:0]	afifo_rd_data_count, 	// cam_cont_afiforead data count
	output	wire	afifo_overflow, // cam_cont_afifo overflow
	output	wire	afifo_underflow	// cam_cont_afifo underflow
);
	
	wire afifo_wr_en;
	wire [15:0] afifo_din;
	reg y_pos;
	wire afifo_full;
	
	parameter	UV_state =	1'b0,
				Y_state =	1'b1;
	reg YUV_state;
	
	reg	[15:0] count;
	reg [8:0] href_count;
	reg [9:0] h_count;
	reg cam_href_3d;
	reg msync_ddr2_d1, msync_ddr2_d2, msync_ddr2_d3, msync_ddr2_d4;
	reg start_flag;
	
	parameter	HOLD_STATE=		1'b0,
				CAPTURE_STATE=	1'b1;
	reg capt_state;
	reg capt_ena;
	
	
	// 񓯊FIFO Write(16rbgA32[xjAReadi32rbgA16[xj
	cam_cont_afifo cam_cont_afifo_inst (
		.rst(reset_ddr2),
		.wr_clk(clk_cam),
		.rd_clk(clk_ddr2),
		.din(afifo_din), // Bus [15 : 0] 
		.wr_en(afifo_wr_en),
		.rd_en(data_enable),
		.dout(data_out), // Bus [31 : 0] 
		.full(afifo_full),
		.overflow(afifo_overflow),
		.empty(afifo_empty),
		.underflow(afifo_underflow),
		.rd_data_count(afifo_rd_data_count) // Bus [4 : 0] 
	);
	
	// ŏmaster_sync ܂ł́AYUVf[^oȂ悤ɂ
	always @(posedge clk_cam) begin
		if (reset_cam)
			start_flag <= 1'b0;
		else
			if (master_sync)
				start_flag <= 1'b1;
	end
	
	// U,VY\Xe[g}V
	always @(posedge clk_cam) begin
		if (reset_cam)
			YUV_state <= UV_state;
		else begin
			case (YUV_state)
				UV_state :
					if (cam_href_2d && start_flag)
						YUV_state <= Y_state;
					else
						YUV_state <= UV_state;
				Y_state :
					YUV_state <= UV_state;
			endcase
		end
	end
	
	// afifo_din cam3_data_2d cam1_data_2d A
	assign afifo_din = {cam3_data_2d, cam1_data_2d};
	// cam_cont_afifo wr_en YUV_state Y_state ̎
	assign afifo_wr_en = (YUV_state==Y_state && capt_ena) ? 1'b1 : 1'b0;
	
	// master_sync clk_ddr2 ɓ
	always @(posedge clk_ddr2) begin
		if (reset_ddr2) begin
			msync_ddr2_d1 <= 1'b0;
			msync_ddr2_d2 <= 1'b0;
			msync_ddr2_d3 <= 1'b0;
			msync_ddr2_d4 <= 1'b0;
		end else begin
			msync_ddr2_d1 <= master_sync;
			msync_ddr2_d2 <= msync_ddr2_d1;
			msync_ddr2_d3 <= msync_ddr2_d2;
			msync_ddr2_d4 <= msync_ddr2_d3;
		end
	end
	
	// AhXpJE^@640*480 = 307,200(hex 4b000)JEg
	always @(posedge clk_ddr2) begin
		if (reset_ddr2)
			address <= 0;
		else begin	
			if (msync_ddr2_d3==1'b1 && msync_ddr2_d4==1'b0) // 1t[Î0ɖ߂
				address <= 0;
			else if (addr_enable && start_flag)
					address <= address + 19'd4; // DDR2 SDRAM1݂̏416rbgf[^ނ
		end
	end
	
	// CMOSJf[^̃Lv`
	always @(posedge clk_cam) begin
		if (reset_cam) begin
			capt_state <= HOLD_STATE;
			capt_ena <= 1'b0;
		end else begin
			case (capt_state)
				HOLD_STATE :
					if (capture_ena && master_sync) begin
						capt_state <= CAPTURE_STATE;
						capt_ena <= 1'b1;
					end
				CAPTURE_STATE :
					if (~capture_ena && master_sync) begin
						capt_state <= HOLD_STATE;
						capt_ena <= 1'b0;
					end
			endcase
		end
	end
					
endmodule

`default_nettype wire

	