// VGA Display Controller
// SRAM24MHzA16bit21ǂ݂ꂽPxRGBɕϊăJ[ŕ\
// UVf[^͂āAYUV-RGBϊsBϊ͈ȉ̂̂gp
// R = (Y<<8 + "1_0110_0100"*V - X"B380")>>8
// G = (Y<<8 - "1011_0111"*V - "0101_1000"*U + X"8780")>>8
// B = (Y<<8 + "1_1100_0110"*U - X"E300")>>8
// ̎ŌvZsBrbg19rbg
// YUVf[^ۑp񓯊FIFO, Wirte32rbg128[xARead16rbg256[xƂBAFIFO_FULL_VALwr_data_countɒBƂɃNGXg~߂ƁA̎_ŗvĂReadṽf[^AĂ邽߂ł

`default_nettype none

// synthesis translate_off
`include "std_ovl_defines.h"
// synthesis translate_on

module VGA_Display_Controller (
	input	wire	clk_cam,	// 25MHzCMOSJpNbN
	input	wire	clk_ddr2,	// 133.33MHzDDR2 SDRAMpNbN
	input	wire	reset_cam,	// clk_cam pZbg
	input	wire	reset_ddr2,	// clk_ddr2 pZbg
	output	reg		request,		// f[^]request
	input	wire	grant,		// f[^]grant
	output	wire	[18:0]	address,	// DDR2 SDRAM̃AhX
	output	reg		req_we,		// ReadvWrite Enable
	input	wire	addr_fifo_full,	// ReadvpFIFOFULL
	input	wire	[31:0]	data_in,	// DDR2 SDRAM̉摜f[^(YUV)
	input	wire	data_valid,
	output	reg		[7:0]	red_out,
	output	reg		[7:0]	green_out,
	output	reg  	[7:0]	blue_out,
	output	reg 	hsyncx,
	output	reg 	vsyncx,
	output	wire	afifo_overflow, // 񓯊FIFO ̃I[o[t[EG[
	output	wire	afifo_underflow,	// 񓯊FIFO ̃A_[t[EG[
	output	reg		addr_is_zero,	// for test
	output	reg		h_v_is_zero		// for test
);
	`include "./disp_timing_parameters.vh"
	
	parameter AFIFO_FULL_VAL = 7'b100_0000; // Write̒lBWrite32rbgȂ̂ŁA64Read128ƂȂ
	parameter AFIFO_HALF_FULL_VAL = 7'b010_0000; // Write̒lBWrite32rbgȂ̂ŁA32Read64ƂȂ
	
	parameter PIXEL_OFFSET = 8'd10;	// Eڗp摜̉ʒ[̃ItZbg
	
	parameter [3:0]	idle_rdg=			4'b0001,
					init_full_mode=		4'b0010,
					wait_half_full=		4'b0100,
					req_burst=			4'b1000;
	reg	[3:0] cs_rdg;
	parameter [1:0]	req_we_low=		2'b01,
					req_we_high=	2'b10; // active
	reg [1:0] cs_vrw;
	reg afifo_rd_en;
	wire [15:0] afifo_dout;
	wire afifo_full;
	wire afifo_empty;
	wire [6:0] wr_data_count;
	reg [18:0] addr_count;
	wire hv_count_enable;
	reg [6:0] read_count;
	reg hv_cnt_ena_d1, hv_cnt_ena_d2;
	reg [10:0] h_count;
	reg [9:0] v_count;
	reg [7:0] red_node, green_node, blue_node;
	reg hsyncx_node, vsyncx_node;
	wire [7:0] cam1y, cam3y;
	reg addr_is_zero_node, h_v_is_zero_node;
	wire [9:0] average;
	reg	[7:0] reye_pixel;
	wire	ldb_srst;
	reg	ldb_rd_en;
	wire	ldb_full, ldb_empty, ldb_underflow;
	wire	[7:0]	cam1y_dout;
	
	// parameter VGA_CON_STAR_ADDR = 16;
	parameter VGA_CON_STAR_ADDR = 8;
	
	// synthesis translate_off
	wire [`OVL_FIRE_WIDTH-1:0] fire_overflow, fire_underflow;
	// synthesis translate_on
	
	// YUVf[^ۑp񓯊FIFO, Wirte32rbg128[xARead16rbg256[xƂ
	cam_data_afifo camd_afifo_inst (
		.rst(reset_ddr2),
		.wr_clk(clk_ddr2),
		.rd_clk(clk_cam),
		.din(data_in), // Bus [31 : 0] 
		.wr_en(data_valid),
		.rd_en(afifo_rd_en),
		.dout(afifo_dout), // Bus [15 : 0] 
		.full(afifo_full),
		.overflow(afifo_overflow),
		.empty(afifo_empty),
		.underflow(afifo_underflow),
		.wr_data_count(wr_data_count) // Bus [6 : 0] 
	);
	
	// DDR2 SDRAM̃AhXJE^iDDR2 SDRAMNbNhCjJE^̒Pʂ16rbg=1fiUY܂VYj
	always @(posedge clk_ddr2) begin
		if (reset_ddr2)
			addr_count <= VGA_CON_STAR_ADDR;
		else begin
			if (addr_count>=(H_ACTIVE_VIDEO * V_ACTIVE_VIDEO)) // 1t[`ÎŁA0ɃNA
				addr_count <= 0;
			else if (req_we) // DDR2 SDRAMւReadvwełJEgAbv
				addr_count <= addr_count + 19'd4; // DDR2 SDRAM4o[XĝŁA{4
		end
	end
	assign address = addr_count;
	
	// Read R}hW[
	
	// Read R}hW[pXe[g}V
	always @(posedge clk_ddr2) begin
		if (reset_ddr2)
			cs_rdg <= idle_rdg;
		else begin
			case (cs_rdg)
				idle_rdg :
					cs_rdg <= init_full_mode;
				init_full_mode : // ŏcam_data_afifo FULLɂXe[gÃXe[głVGAM͏o͂ȂŁAЂcam_data_afifo FULLɂȂ̂҂B
					if (wr_data_count>=AFIFO_FULL_VAL)
						cs_rdg <= wait_half_full;
					else
						cs_rdg <= init_full_mode;
				wait_half_full : // cam_data_afifo HALF_FULLɂȂ܂ł̃Xe[gőҋ@
					if (wr_data_count<=AFIFO_HALF_FULL_VAL)
						cs_rdg <= req_burst;
					else
						cs_rdg <= wait_half_full;
				req_burst :
					if (read_count==0 && wr_data_count>AFIFO_HALF_FULL_VAL) // VRAMREADvJEgJE^0ɂȂāAwr_data_count HALF_FULLȏɂȂ
						cs_rdg <= wait_half_full;
					else
						cs_rdg <= req_burst;
			endcase
		end
	end
	assign hv_count_enable = (cs_rdg==wait_half_full || cs_rdg==req_burst) ? 1'b1 : 1'b0;
	
	// request ̎BVRAM̃f[^ReadƂɃANeBx[gBA[r^
	always @(posedge clk_ddr2) begin
		if (reset_ddr2)
			request <= 1'b0;
		else begin
			if (cs_rdg==req_burst || cs_rdg==init_full_mode)
				request <= 1'b1;
			else
				request <= 1'b0;
		end
	end
	
	// read_count ̎ADDR2 SDRAM ւReadṽJEgB
	always @(posedge clk_ddr2) begin
		if (reset_ddr2)
			read_count <= AFIFO_HALF_FULL_VAL;
		else begin
			if (cs_rdg==wait_half_full)
				read_count <= AFIFO_HALF_FULL_VAL;
			else if (cs_rdg==req_burst) begin
				if (read_count!=0 && addr_fifo_full==1'b0) // 0ɂȂ܂ŁAVRAMւ̗vAhXFIFOFULLłȂɗv
					read_count <= read_count - 1;
			end
		end
	end
	
	// req_we ̎Areq_we ̓NbN21o͂B邱Ƃɂaddr_fifo_full ݂̂łAreq_we FFo͂Ƃ邱ƂłBREAD̃CeV͒̂ŁA21ReadvsłȂ͂BBB
	always @(posedge clk_ddr2) begin
		if (reset_ddr2) begin
			cs_vrw <= req_we_low;
			req_we <= 1'b0;
		end else begin
			case (cs_vrw)
				req_we_low :
					if ((cs_rdg==req_burst || cs_rdg==init_full_mode) && read_count!=0 && ~addr_fifo_full && grant) begin // ŏpixel_async_fifo FULLɂ鎞HALF܂ōsFULLɂƂ
						cs_vrw <= req_we_high;
						req_we <= 1'b1;
					end
				req_we_high : begin
					cs_vrw <= req_we_low;
					req_we <= 1'b0;
				end
			endcase
		end
	end
	// Read R}hW[,I	
	
	// rbg}bvVGARg[clk_cam (25MHz)암
	
	// h_countAv_countp133.33MHzcs_rdg ̒lgp̂225MHzFFŃb`
	always @(posedge clk_cam) begin
		if (reset_cam) begin
			hv_cnt_ena_d1 <= 1'b0;
			hv_cnt_ena_d2 <= 1'b0;
		end else begin
			hv_cnt_ena_d1 <= hv_count_enable;
			hv_cnt_ena_d2 <= hv_cnt_ena_d1;
		end
	end
	
	// h_count̎iJE^j
	always @(posedge clk_cam) begin
		if (reset_cam)
			h_count <= 0;
		else if (h_count>=(H_SUM-1)) // h_count H_SUM-1傫0ɖ߂(mod H_SUM)
			h_count <= 0;
		else if (hv_cnt_ena_d2) // ŏɔ񓯊FIFOtɂ܂ł̓JEgȂ
			h_count <= h_count + 11'd1;
	end
	
	// v_count̎iJE^j
	always @(posedge clk_cam) begin
		if (reset_cam)
			v_count <= 0;
		else if (h_count>=(H_SUM-1)) begin // JE^NAƂ
			if (v_count>=(V_SUM-1)) // v_count V_SUM-1傫0ɖ߂(mode V_SUM)
				v_count <= 0;
			else if (hv_cnt_ena_d2) // ŏɔ񓯊FIFOtɂ܂ł̓JEgȂ
				v_count <= v_count + 10'd1;
		end
	end
	
	assign cam1y = afifo_dout[7:0]; // 8rbg cam1
	assign cam3y = afifo_dout[15:8]; // 8rbg
	
	assign ldb_srst = (~hsyncx_node || reset_cam) ? 1'b1 : 1'b0;
	line_delay_buf line_delay_buf_inst (
		.clk(clk_cam), // input clk
		.srst(ldb_srst), // input srst
		.din(cam1y), // input [7 : 0] din cam1
		.wr_en(afifo_rd_en), // input wr_en
		.rd_en(ldb_rd_en), // input rd_en
		.dout(cam1y_dout), // output [7 : 0] dout
		.full(ldb_full), // output full
		.empty(ldb_empty), // output empty
		.underflow(ldb_underflow) // output underflow
	);
	always @(posedge clk_cam) begin
		if (reset_cam)
			ldb_rd_en <= 1'b0;
		else begin
			if (h_count>=PIXEL_OFFSET && h_count<H_ACTIVE_VIDEO+PIXEL_OFFSET)
				ldb_rd_en <= 1'b1;
			else
				ldb_rd_en <= 1'b0;
		end
	end
			
	assign average = {2'b00, cam1y} + {2'b00, cam3y};
	// Red, Green, Blueo
	always @(posedge clk_cam) begin
		if (reset_cam) begin
			red_node <= 0;
			green_node <= 0;
			blue_node <= 0;
		end else begin
			if (~hv_cnt_ena_d2) begin // ŏpixel_async_fifo tɂȂ܂ŉ摜f[^o͂ȂB
				red_node <= 0;
				green_node <= 0;
				blue_node <= 0;
			end else if (h_count<H_ACTIVE_VIDEO && v_count<V_ACTIVE_VIDEO) begin // \ĂԂ̂݉摜f[^o͂
				red_node <= cam1y;
				// red_node <= cam1y_dout;
				green_node <= 0;
				blue_node <= cam3y;
			end else begin
				red_node <= 0;
				green_node <= 0;
				blue_node <= 0;
			end 
				
		end
	end
	always @(posedge clk_cam) begin
		if (reset_cam) begin
			red_out <= 0;
			green_out <= 0;
			blue_out <= 0;
		end else begin
			red_out <= red_node;
			green_out <= green_node;
			blue_out <= blue_node;
		end
	end
	
	// hsyncx óiMj
	always @(posedge clk_cam) begin
		if (reset_cam)
			hsyncx_node <= 1'b1;
		else
			if (h_count>(H_ACTIVE_VIDEO + H_FRONT_PORCH-1) && h_count<=(H_ACTIVE_VIDEO + H_FRONT_PORCH + H_SYNC_PULSE-1)) // 
				hsyncx_node <= 1'b0;
			else
				hsyncx_node <= 1'b1;
	end
	always @(posedge clk_cam) begin
		if (reset_cam)
			hsyncx <= 1'b1;
		else
			hsyncx <= hsyncx_node;
	end
	
	// vsyncx óiMj
	always @(posedge clk_cam) begin
		if (reset_cam)
			vsyncx_node <= 1'b1;
		else
			if (v_count>(V_ACTIVE_VIDEO + V_FRONT_PORCH-1) && v_count<=(V_ACTIVE_VIDEO + V_FRONT_PORCH + V_SYNC_PULSE-1)) // 
				vsyncx_node <= 1'b0;
			else
				vsyncx_node <= 1'b1;
	end
	always @(posedge clk_cam) begin
		if (reset_cam)
			vsyncx <= 1'b1;
		else
			vsyncx <= vsyncx_node;
	end
	
	// afifo_rd_en ̏
	always @(posedge clk_cam) begin
		if (reset_cam)
			afifo_rd_en <= 1'b0;
		else begin
			if (~hv_cnt_ena_d2) // 
				afifo_rd_en <= 1'b0;
			else if (h_count<H_ACTIVE_VIDEO && v_count<V_ACTIVE_VIDEO) // \
				afifo_rd_en <= 1'b1;
			else
				afifo_rd_en <= 1'b0;
		end
	end

	
	// AT[V
	// synthesis translate_off
	// always @ (posedge clk_ddr2) begin
		// if (reset_ddr2)
			// ;
		// else begin
			// if (afifo_overflow) begin 
				// $display("%m: at time %t ERROR : FIFOtȂ̂ɃCg",$time);
				// $stop;
			// end
		// end
	// end
	// always @(posedge clk_cam) begin
		// if (reset_cam)
			// ;
		// else begin
			// if (afifo_underflow) begin
				// $display("%m: at time %t ERROR : FIFOȂ̂Ƀ[h",$time);
				// $stop;
			// end
		// end
	// end
	
	ovl_never #(
		`OVL_ERROR,			// severity_level
		`OVL_ASSERT,		// property_type
		"ERROR : FIFOtȂ̂ɃCg", // msg
		`OVL_COVER_DEFAULT,	// coverage_level
		`OVL_POSEDGE,		// clock_edge
		`OVL_ACTIVE_HIGH,	// reset_polarity
		`OVL_GATE_CLOCK	// gating_type
	) afifo_overflow_assertion (
		clk_ddr2,
		reset_ddr2,
		1'b1,
		afifo_overflow,
		fire_overflow
	);
		
	ovl_never #(
		`OVL_ERROR,			// severity_level
		`OVL_ASSERT,		// property_type
		"ERROR : FIFOȂ̂Ƀ[h", // msg
		`OVL_COVER_DEFAULT,	// coverage_level
		`OVL_POSEDGE,		// clock_edge
		`OVL_ACTIVE_HIGH,	// reset_polarity
		`OVL_GATE_CLOCK	// gating_type
	) afifo_underflow_assertion (
		clk_cam,
		reset_cam,
		1'b1,
		afifo_underflow,
		fire_underflow
	);
	// synthesis translate_on
	
	//  for test
	always @(posedge clk_ddr2) begin
		if (reset_ddr2) begin
			addr_is_zero_node <= 1'b0;
			addr_is_zero <= 1'b0;
		end else begin
			if (addr_count == 0)
				addr_is_zero_node <= 1'b1;
			else
				addr_is_zero_node <= 1'b0;
			addr_is_zero <= addr_is_zero_node;
		end
	end
	always @(posedge clk_cam) begin
		if (reset_cam) begin
			h_v_is_zero_node <= 1'b0;
			h_v_is_zero <= 1'b0;
		end else begin
			if (h_count==0 && v_count==0)
				h_v_is_zero_node <= 1'b1;
			else
				h_v_is_zero_node <= 1'b0;
			h_v_is_zero <= h_v_is_zero_node;
		end
	end
			
endmodule

`default_nettype wire
